##
# Class Gato: Esta clase estable las reglas para el juego del Gato.
# Se llama al metodo jugar(x,y) para poner una ficha en el lugar
# indicado y cambia el turno automaticamente. Luego de poner la ficha
# detecta si el jugador ha ganado o no.
#
# El estado del juego se mantiene en una matriz de 3x3. Dependiendo del
# valor de la casilla se tiene:
#	(0)->Casilla vacia. 
#	(1)->Ficha del jugador 1.
# 	(2)->Ficha del jugador 2
##
class Gato:
    def __init__(self):
        self.turno=False # False-> Jugador 1. True->Jugador 2
        self.n=3 # Tamano del tablero
        self.matriz=self.inicializar(self.n) # Crea el tablero

    def inicializar(self,n):
    ##
    #	Se debe crear una matriz llena de ceros y retornarla
    ##
		matriz = []
		for i in range(n):
			matriz.append([0]*n)
		return matriz
		        
    def jugar(self,x,y):
    ##
    # Realizar una jugada implica anotar un 1 o un 2 en la casilla
    # (x,y) solo si la casilla esta vacia. Tambien se debe detectar
    # si alguien gano el juego en esta jugada.
    # Retorna True si la jugada es valida, Flase si no.
    ##
    	self.matriz[x][y] = 1 #borrar
    	return True #borrar

    def check_h(self,y):
    ##
    # Retorna True si hay un ganador en la fila y. False si no.
    # Debe revisar si hay tres piezas del jugador actual en esa fila.
    ##
    	pass #borrar
    	
    def check_v(self,x):
    ##
    # Retorna True si hay un ganador en la columna x. False si no.
    # Debe revisar si hay tres piezas del jugador actual en esa columna.
    ##
    	pass #borrar
        	
        
    def check_d(self,x,y):
   	##
    # Retorna True si hay un ganador en alguna diagonal False si no.
    # Revisa la diagonal correspondiente si x,y es una esquina. Si x,y
    # resulta ser el centro del tablero debe revisar dos diagonales
    ##
		if self.turno:
			val = 2
		else:
			val = 1
		ok = False
		
		if(x==0 and y==0) or (x==2 and y==2):
			x=0; y=0
			for i in range(3):
				if self.matriz[x][y]==val:
					ok = True
				else:
					ok = False
					return False
				x+=1; y+=1
			return ok
			
		elif(x==2 and y==0) or (x==0 and y==2):
			x=2; y=0
			for i in range(3):
				if self.matriz[x][y]==val:
					ok = True
				else:
					ok = False
					return False
				x-=1; y+=1
			return ok
		
		elif(x==1 and 1==1):
			x=0; y=0
			for i in range(3):
				if self.matriz[x][y]==val:
					ok = True
				else:
					ok = False
					return False
				x+=1; y+=1
			if ok:
				return True
			
			x=2; y=0
			for i in range(3):
				if self.matriz[x][y]==val:
					ok = True
				else:
					ok = False
					return False
				x-=1; y+=1
			return ok
		
		else:
			return False
	
        
    def ganador(self,x,y):
    ##
    # Revisa si el jugador actual consigue una jugada ganadora. Revisa
    # cada fila y diagonal correspondiente a la posicion actual
    ##
        if self.check_h(y) or self.check_v(x) or self.check_d(x,y):
        	return True
        else:
        	return False
        
